<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: hash_map_kernel_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_c5be2c1c2ca76d8ca371318dffb1d37f.html">hash_map</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">hash_map_kernel_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2003  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_HASH_MAP_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_HASH_MAP_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../general_hash/general_hash.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../interfaces/enumerable.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../interfaces/remover.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../interfaces/map_pair.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">typename</span> domain,</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">typename</span> range,</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> expnum,</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keyword">typename</span> mem_manager = <a class="code" href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">default_memory_manager</a>,</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">typename</span> compare = std::less&lt;T&gt;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        &gt;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">class </span>hash_map : <span class="keyword">public</span> enumerable&lt;map_pair&lt;domain,range&gt; &gt;,</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;                     <span class="keyword">public</span> pair_remover&lt;domain,range&gt;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="keyword">typedef</span> domain domain_type;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            <span class="keyword">typedef</span> range range_type;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            <span class="keyword">typedef</span> compare compare_type;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <span class="keyword">typedef</span> mem_manager mem_manager_type;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            hash_map(</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            );</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keyword">virtual</span> ~hash_map(</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            ); </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            <span class="keywordtype">void</span> clear(</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            );</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            <span class="keywordtype">void</span> add (</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;                domain&amp; d,</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;                range&amp; r</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            );</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <span class="keywordtype">bool</span> is_in_domain (</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                <span class="keyword">const</span> domain&amp; d</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            <span class="keywordtype">void</span> remove (</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                <span class="keyword">const</span> domain&amp; d,</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                domain&amp; d_copy,</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                range&amp; r</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;            );</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            <span class="keywordtype">void</span> destroy (</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                <span class="keyword">const</span> domain&amp; d</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            );</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            range&amp; operator[] (</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                <span class="keyword">const</span> domain&amp; d</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            );</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            <span class="keyword">const</span> range&amp; operator[] (</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                <span class="keyword">const</span> domain&amp; d</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            ) <span class="keyword">const</span>;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                hash_map&amp; item</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;            );</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <span class="keyword">private</span>:</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160; </div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            <span class="comment">// restricted functions</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;            hash_map(hash_map&amp;);        </div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;            hash_map&amp; operator=(hash_map&amp;);   </div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    };</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160; </div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keyword">typename</span> domain,</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keyword">typename</span> range,</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> expnum,</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keyword">typename</span> mem_manager,</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keyword">typename</span> compare</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        &gt;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        hash_map&lt;domain,range,expnum,mem_manager,compare&gt;&amp; a, </div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        hash_map&lt;domain,range,expnum,mem_manager,compare&gt;&amp; b </div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    ) { a.swap(b); }   </div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="keyword">typename</span> domain,</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="keyword">typename</span> range,</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> expnum,</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="keyword">typename</span> mem_manager,</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        <span class="keyword">typename</span> compare</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        &gt;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        hash_map&lt;domain,range,expnum,mem_manager,compare&gt;&amp; item,</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        std::istream&amp; in</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    );   </div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;}</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160; </div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="preprocessor">#endif // DLIB_HASH_MAP_KERNEl_ABSTRACT_</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html_ae8aaef18fce6452263f46535116308ca"><div class="ttname"><a href="namespacedlib.html#ae8aaef18fce6452263f46535116308ca">dlib::default_memory_manager</a></div><div class="ttdeci">memory_manager_stateless_kernel_1&lt; char &gt; default_memory_manager</div><div class="ttdef"><b>Definition:</b> algs.h:129</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
